/***************************************************************************
                          monk.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MONK_H
#define MONK_H

#include "gameobject.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Sprite;
class Maptile_teleporter;
class Monk_Ai;

class Monk : public Gameobject
{
public: 
	Monk(int _x, int _y, int _dx, int _dy, Map_Sample* _sample);
	~Monk();

	void act();
	void show();

	void die();
	void get_ran_pos();
	void trap();
	void gas();
	void check_movement();
	void check_transfer();
	void check_gom();
	void teleport(Maptile_teleporter* _dest);
	bool in_hole();

	bool have_g();

	bool move_left();
	bool move_right();
	bool move_up();
	bool move_down();
	bool move_hleft();
	bool move_hright();

private:
	Sprite* sprite;
	bool gased, trapped, port, fob, hole, falling, transfer, eating, po;
	int have_gold;
	Timer* ctimer;
	Timer* bar;
	int dx, dy, px, py, bl;
	Maptile_teleporter* dest;
	Timer* ttimer;
  float skill;

	Monk_Ai* monk_ai;
};

#endif
